<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGroupCombination ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGroupCombination
 * @subpackage Arrays
 */
class ArrayOfGroupCombination extends AbstractStructArrayBase
{
    /**
     * The GroupCombination
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\GroupCombination[]
     */
    public $GroupCombination;
    /**
     * Constructor method for ArrayOfGroupCombination
     * @uses ArrayOfGroupCombination::setGroupCombination()
     * @param \patest\StructType\GroupCombination[] $groupCombination
     */
    public function __construct(array $groupCombination = array())
    {
        $this
            ->setGroupCombination($groupCombination);
    }
    /**
     * Get GroupCombination value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\GroupCombination[]|null
     */
    public function getGroupCombination()
    {
        return isset($this->GroupCombination) ? $this->GroupCombination : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGroupCombination method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGroupCombination method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGroupCombinationForArrayConstraintsFromSetGroupCombination(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGroupCombinationGroupCombinationItem) {
            // validation for constraint: itemType
            if (!$arrayOfGroupCombinationGroupCombinationItem instanceof \patest\StructType\GroupCombination) {
                $invalidValues[] = is_object($arrayOfGroupCombinationGroupCombinationItem) ? get_class($arrayOfGroupCombinationGroupCombinationItem) : sprintf('%s(%s)', gettype($arrayOfGroupCombinationGroupCombinationItem), var_export($arrayOfGroupCombinationGroupCombinationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GroupCombination property can only contain items of type \patest\StructType\GroupCombination, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GroupCombination value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\GroupCombination[] $groupCombination
     * @return \patest\ArrayType\ArrayOfGroupCombination
     */
    public function setGroupCombination(array $groupCombination = array())
    {
        // validation for constraint: array
        if ('' !== ($groupCombinationArrayErrorMessage = self::validateGroupCombinationForArrayConstraintsFromSetGroupCombination($groupCombination))) {
            throw new \InvalidArgumentException($groupCombinationArrayErrorMessage, __LINE__);
        }
        if (is_null($groupCombination) || (is_array($groupCombination) && empty($groupCombination))) {
            unset($this->GroupCombination);
        } else {
            $this->GroupCombination = $groupCombination;
        }
        return $this;
    }
    /**
     * Add item to GroupCombination value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\GroupCombination $item
     * @return \patest\ArrayType\ArrayOfGroupCombination
     */
    public function addToGroupCombination(\patest\StructType\GroupCombination $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\GroupCombination) {
            throw new \InvalidArgumentException(sprintf('The GroupCombination property can only contain items of type \patest\StructType\GroupCombination, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GroupCombination[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\GroupCombination|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\GroupCombination|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\GroupCombination|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\GroupCombination|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\GroupCombination|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GroupCombination
     */
    public function getAttributeName()
    {
        return 'GroupCombination';
    }
}
